/*
*	This educational eample serves to show the process of creating a dataviz from dirty data
* It still has a lot of intermediate steps you would remove if you were to put the code into production
*/
// console.log(d3)
const url = 'https://gist.githubusercontent.com/sahitj001/26850a99179af9f089a879f00cc7daad/raw/d276697fc13e60c07f2bec4078da9148f74dcf79/parkingData.json'



  const getData = async () => {
    try {
      const data = await d3.json(url)
      theData = data
    } catch (error) {
      console.log(error)
    }
  }

const theData

  function totalPerProvince() {
    //calculate the total capacity per province
    const total = d3collection.nest().key(function (d) { //with .key you create for each unique element a key, so we should get 12 provinces
        return d.province
      })
      .rollup(function (d) { //with .rollup you take all the individual values in each key
        return d3.sum(d, function (y) { //and then sum them up
          return y.capacity
        })
      }).entries(data) //the data we are using
      .sort((a, b) => d3.descending(a.value, b.value)) //then sort data from high to low


    const theBars = svg.selectAll('.bar')
      .data(total)

    //updating the bars
    theBars
      .attr('x', d => x(d.key))
      .attr('y', d => y(d.value))
      .attr('width', x.bandwidth())
      .attr('height', d => sizes.height - y(d.value))

    //by updating the domain, you set up the scaling of your axes  
    x.domain(total.map(province => province.key))
    y.domain([0, d3.max(total.map(capacity => capacity.value))])

    //update the axes
    svg.select('.xAxis')
      .call(d3.axisBottom(x))
      .attr('transform', 'translate(0,' + sizes.height + ')')
    svg.select('.yAxis')
      .call(d3.axisLeft(y).ticks(10))

    theBars.exit()
      .remove()

    return total
  }